<template>
    <div class="roundSelectedCards container center text-center">
        <h3>All cards selected in this round</h3>
        <table class="text-center center">
            <tr>
                <td>
                    <Hint v-bind:roundId="roundId"></Hint>
                </td>
                <td>
                    <Points></Points>
                </td>
            </tr>
        </table>
        <div class="row text-center">
            <h3>Choose the Storyteller's card</h3>
            <div class="column  d-flex justify-content-center" v-for="card in selectedCards" :key="card.id">
                <img class="card" v-bind:src="getSelectedCard(card.fileName)" v-on:click="guessCard(card.id)"/>
            </div>
        </div>
        <RemainingCards v-bind:playerId="playerId"></RemainingCards>
    </div>
</template>
<script>
    import axios from 'axios';
    import Points from './Points.vue';
    import Hint from "./Hint.vue";
    import RemainingCards from "./RemainingCards.vue";
    export default {
        name: 'roundSelectedCard',
        data: function () {
            return {
                selectedCards: [],
                roundId: this.$route.params.roundId,
                playerId: this.$route.params.playerId,
            }
        },
        components: {
            Hint,
            RemainingCards,
            Points
        },
        methods: {
            getSelectedCard(filename) {
                return require('../assets/' + filename);
            },
            retrieveSelectedCards() {
                axios.get("https://localhost:44361/api/round/" + this.roundId + "/selectedCards")
                    .then(response => this.selectedCards = response.data);
            },
            guessCard(cardId) {
                axios.post("https://localhost:44361/api/card/" + cardId + "/player/" +
                    this.playerId + "/round/" + this.roundId + "/guess", {
                    playerId: this.playerId,
                    roundId: this.roundId,
                    cardId: cardId
                })
                    .then(this.redirect());
            },
            redirect() {
                    this.$router.push({
                        name: 'waitForOtherGuesses',
                        params: {
                            playerId: this.$route.params.playerId,
                            gameId: this.$route.params.gameId,
                            roundId: this.$route.params.roundId,
                            cardId: this.$route.params.cardId
                        }
                    })
            },
        },
        created: function () {
            this.retrieveSelectedCards();
        }
    }
</script>

<style scoped>
    .card {
        height: 250px;
        display: flex;
    }
    .column {
        float: left;
        width: 33.33%;
        padding: 5px;
    }
    .center {
  margin-left: auto;
  margin-right: auto;
    }
     td {
        padding: 20px;
    }
</style>
